/*****************************************************************************
*
* Emrah Akin Sisbot
* Aug 10 
*
* File : sparkm3d.h
* Brief: This file exports the variables of Move3D to genom module
*
******************************************************************************/

#ifndef SPARKM3D_H
#define SPARKM3D_H

/*----------------------------------------------------------------------------
  INCLUDE
-----------------------------------------------------------------------------*/

#include "Util-pkg.h"
#include "P3d-pkg.h"
#include "Planner-pkg.h"
#include "Localpath-pkg.h"
#include "Collision-pkg.h"
#include "Graphic-pkg.h"
#include "Hri_planner-pkg.h"
#include "Move3d-pkg.h"
#include "LightPlanner-pkg.h"

#include <sys/time.h>

#define D2D(x1,y1,x2,y2) (sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)))
#define D3D(x1,y1,z1,x2,y2,z2) (sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)+(z2-z1)*(z2-z1)))

#define COND_PRINT(cond,str)  if( cond ) printf str
#define DEBUG_PRINTF(level,str)  if(SDI_F->State.debug_mode && (level <= SDI_F->State.debug_mode) ) printf str

extern hri_bitmapset * BTSET;
extern hri_bitmapset * ACBTSET; // ACBTSET is a global variable used for mightabilities

extern p3d_env * gEnv;
extern HRI_AGENT * gRobot;
extern hri_bitmapset * gBtset;
extern hri_gik * gGik;
extern HRI_AGENTS * gAgents;
extern HRI_ENTITIES * gEntities;
extern int Mightability_Maps_Initialized;

/*----------------------------------------------------------------------------
  STRUCTURES
  -----------------------------------------------------------------------------*/
 
/* typedef struct STRUCT_SPARK_ALL_REACHABILITIES { */
/*   SPARK_AGENT_REACHABILITY * agentReach; */
/*   int agentReachNb; */
/* } SPARK_ALL_REACHABILITIES;  */

typedef struct STRUCT_SPARK_OBJECT_MOTION_HISTORY_ARRAY {
  SPARK_OBJECT_MOTION motion[SPARK_OBJ_STATE_MAX][SPARK_OBJECT_HISTORY_LENGTH];
  unsigned long sensorTime [SPARK_OBJ_STATE_MAX][SPARK_OBJECT_HISTORY_LENGTH];
  int length;
} SPARK_OBJECT_MOTION_HISTORY_ARRAY;

typedef struct STRUCT_SPARK_AGENT_HISTORY_UNIT {
  SPARK_6D_COORD head;
  SPARK_3D_COORD lhand;
  SPARK_3D_COORD rhand;
  unsigned long headSensorTime;
} SPARK_AGENT_HISTORY_UNIT;

typedef struct STRUCT_SPARK_AGENT_HISTORY {
  SPARK_AGENT_HISTORY_UNIT history[SPARK_HUMAN_HISTORY_LENGTH];
  int length;
} SPARK_AGENT_HISTORY;

typedef struct STRUCT_SPARK_AGENT_SENSOR_DATA{
  int positionAv;
  int headAv;
  SPARK_6D_COORD head;
  int rightHandAv;
  SPARK_3D_COORD rightHand;
  int leftHandAv;
  SPARK_3D_COORD leftHand;
} SPARK_AGENT_SENSOR_DATA;


/*----------------------------------------------------------------------------
  PROTOTYPE
-----------------------------------------------------------------------------*/

extern int timeval_subtract(struct timeval *result, struct timeval *t2, struct timeval *t1);
extern void draw_spark_backbuffer( void );
extern void initialize_interface( void ); 
extern int place_robot_conf_to_environment_poster(p3d_rob* rob, configPt q);
extern void publish_environment_poster( void );
extern void interface_MainLoopEvent();
#endif
